/*
==============================================================================

BG/ROAM/SWIM BOT HEADER FILE

==============================================================================
*/

// Global Constants
float	BOT_CREATE    = 100;	// impulse constant
float	BOT_LEAD_TIME = 2;	// time before changing lead destination
float	BOT_LEAD_DIST = 150;	// distance that bot will stay near leader
float	BOT_LEAD_MIND = 100;	// lead destination trace obstruct distance
float	BOT_PAUSETIME = 0.1;	// time to wait between roams
float	BOT_WATCHDOG  = 5;	// time to camp before trying a jump
				// the relationship between lead time, pause time
				// and watchdog will determine how smoothly the
				// bot moves: pause < lead < watchdog
float	CAMPRANG      =100;	// force bot to move 100 units from last watdog
vector	BOT_JUMP_VECZBIG = '0 0 270';		// z component of long jumps
float	BOT_JUMP_VMLTBIG  = 600;		// forward multiplier long jumps
vector	BOT_JUMP_VECZLOW = '0 0 200';		// z component of jumps
float	BOT_JUMP_VMLTLOW  = 200;		// forward multiplier
vector	BOT_JUMP_VECSWIM = '250 250 0';		// drowning move

// Player Entitiy Fields
.entity		bot;		//pointer to last created bot

// Bot Entity Fields
.entity		stuff;		// pointer for items, used for non-aggression
.entity		lead;		// pointer to bot leader entity
.entity		icecube;	// a homey with the right colors, not teammate
				// but pen pal...
.entity		oldtarg;	// unused, defaults to self, use this for
				// entity that was visible but disappeared

.string		cl;		// "player" and "bot" classname have "client"
				// initialized at spawn, but unused, can serve
				// as a string var

.float		fl_lead;	// bot semaphore to tell leader to suicide
.float		lead_dist;	// bot's distance to leader
.float		watdog;		// bot watchdog timer, normally reset each second
.float		jumptime;	// bot jump timer prevent sequential stuff jump
.float		underwat;	// bot version of non-working player.waterlevel
.float		postity;	// yellow post it
.float		postitp;	// pink post it

.vector		foundatp;	// bot storage of calculated teleport origin
.vector		campsite;	// bot's last position
.vector		marker1;	// bot's slime trail, campsite t-1
.vector		marker2;	// bot's slime trail, campsite t-2
.vector		marker3;	// bot's slime trail, campsite t-3
.vector		marker4;	// bot's slime trail, campsite t-4

.void()		th_stuff;	// think routine for finding stuff

// Bot Leader Entity Fields
.float		dest_time;	// delay between changing lead destination

// External reference (modified client.qc)
void	()						water_checks;

// External reference (unmodified triggers.qc)
void	(vector org)				spawn_tfog;
void	(vector org, entity death_owner)	spawn_tdeath;

// Bot Prototypes - called by player (bot_c.qc)
void () Bot_Precache;		// Precache information for the bot
void (string name, float skinnum, float fragcnt, entity bowner) BotCreate;	// Create bot

// Bot_roam Prototypes - called by bot and leader (bot_roam.qc)
float	(entity t)					target_range;
void	()						bot_lead_destination;
void	()						bot_lead_think;
void	()						bot_lead_spawn;
void	(float dist)					bot_ai_roam;

// Botai Prototypes - called by bot and server (bot_ai.qc)
void	()						bot_ai_stand;
void	()						bot_ai_turn;
void	(float dist)					bot_ai_run;
void	(float dist)					bot_ai_stuff;
void	()						bot_attack;
void	(void () thinkst)				BotCheckRefire;
void	(entity attacker, float damage)			bot_pain;
void	()						bot_die;
void	()						BotSelfDeActivate;

// Bot remove (single player) - called by self (impulse2.qc)
void	()						BotDeActivate;

// Bot_sub Prototypes - called by botai (bot_subs.qc)
float	()						BotFindTarget;
void	()						BotSightSound;
void	()						BotHuntTarget;
float	()						BotLocateStuff;
float	()						BotFindStuff;
void	()						BotSearchStuff;
float	()						BotFindPlayer;
float	()						bot_uw_check;
void	()						bot_ai_swim;
void	()						bot_FireShotgun;
void	()						bot_FireSuperShotgun;
void	()						bot_FireRocket;
void	()						bot_fire;
void	()						bot_fire2;
void	()						bot_SetCurrentAmmo;
float	()						bot_bestweapon;
float	()						bot_CheckNoAmmo;
void	()						BotFixOwners;

// Bot_ext Prototypes - called by triggers.qc (bot_ext.qc)
void	()						bot_counter_use;
void	()						bot_trigger_onlyregistered_touch;
